import asyncio
import os
import queue
import socket
from enum import Enum
from typing import List

from settings import settings


class MsgFromGlintServer(Enum):
    SERVER_START_FAIL = "SERVER_START_FAIL"
    SERVER_READY = "SERVER_READY"
    USER_CONNECTED = "USER_CONNECTED"
    USER_DISCONNECTED = "USER_DISCONNECTED"


QUEUES: List[queue.SimpleQueue] = []


server = None


def listen_for_unix_sock_connections():
    print("listen_for_connections")  # noqa: T201
    sock_n = "/tmp/glint_launcher_service.s"

    if os.path.exists(sock_n):
        os.remove(sock_n)
    global server
    server = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
    server.bind(sock_n)
    os.chmod(sock_n, 0o777)
    while settings.is_running:
        print("Before server.listen(1)")  # noqa: T201
        server.listen(1)
        conn, addr = server.accept()
        print("!!! incoming connection")  # noqa: T201
        datagram = conn.recv(1024)
        if datagram:
            print(datagram.decode())  # noqa: T201
            for msg_queue in QUEUES:
                msg_queue.put_nowait(datagram.decode())
        conn.close()


def stop_unix_sock_listening():
    global server
    if server:
        server.close()


def create_subscriber():
    msg_queue = queue.SimpleQueue()
    QUEUES.append(msg_queue)
    return msg_queue


def delete_subscriber(msg_queue):
    QUEUES.remove(msg_queue)


def get_socket_msg_blocking(msg_queue):
    return msg_queue.get()


async def get_socket_msg(msg_queue):
    while settings.is_running:
        try:
            return msg_queue.get_nowait()
        except queue.Empty:
            pass
        await asyncio.sleep(0.1)
